unit frmarticlelist;

{$mode ObjFPC}

interface

uses
  SysUtils, Classes, Rtl.HTMLActions, htmlfragment, jsondataset, Types,
  sqldbrestdataset, DB, dbwebwidget, webwidget, dbhtmlwidgets, weborworker, frmbase, Web;

type
  THTMLFragment = TBaseForm;
  { TArticleListForm }

  TArticleListForm = class(THTMLFragment)
    divArticleList: THTMLElementAction;
    divNewArticle: THTMLElementAction;
    divNoArticles: THTMLElementAction;
    divSearch: THTMLElementAction;
    rdsArticlesa_author_fk: TLargeintField;
    rdsArticlesa_created_on: TJSONDateTimeField;
    rdsArticlesa_id: TLargeintField;
    rdsArticlesa_text: TStringField;
    rdsArticlesa_title: TStringField;
    rdsArticlesu_firstname: TStringField;
    rdsArticlesu_lastname: TStringField;
    rdsAuthorsu_author: TStringField;
    rdsAuthorsu_firstname: TStringField;
    rdsAuthorsu_id: TLargeintField;
    rdsAuthorsu_lastname: TStringField;
    rdsAuthorsu_login: TStringField;
    rdsAuthorsu_password: TStringField;
    selAuthor: THTMLElementAction;
    alForm: THTMLElementActionList;
    dsArticles: TDataSource;
    dswAuthors: TDBSelectWidget;
    dsAuthors: TDataSource;
    ltwArticleList: TDBLoopTemplateWidget;
    rdsArticles: TSQLDBRestDataset;
    rdsAuthors: TSQLDBRestDataset;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleRendered(Sender: TObject);
    procedure dswAuthorsChange(Sender: TObject; Event: TJSEvent);
    procedure rdsArticlesAfterOpen(DataSet: TDataSet);
    procedure rdsAuthorsCalcFields(DataSet: TDataSet);
  private
  public
    class function FormRoutes: TStringDynArray; override;
  end;

var
  ArticleListForm: TArticleListForm;

implementation

uses dmserver;

{$R *.lfm}

{ TArticleListForm }

procedure TArticleListForm.rdsAuthorsCalcFields(DataSet: TDataSet);

var
  aAuthor : String;

begin
  aAuthor:=rdsAuthorsu_firstname.AsString+' '+rdsAuthorsu_lastname.AsString;
  if (rdsAuthorsu_id.AsLargeInt=Server.UserInfo.ID) then
     aAuthor:='You ('+aAuthor+')';
  rdsAuthorsu_author.AsString:=aAuthor;
end;

procedure TArticleListForm.dswAuthorsChange(Sender: TObject; Event: TJSEvent);

Var
  aAuthorID : Integer;

begin
  aAuthorID:=StrToIntDef(selAuthor.value,-1);
  With rdsArticles.ParamByName('a_author_fk') do
    begin
    AsInteger:=aAuthorID;
    Enabled:=(aAuthorID<>-1);
    end;
  rdsArticles.Close;
  rdsArticles.Load;
end;

procedure TArticleListForm.rdsArticlesAfterOpen(DataSet: TDataSet);
begin
  if Dataset.IsEmpty then
    divNoArticles.RemoveClass('is-hidden')
  else
    divNoArticles.AddClass('is-hidden');
end;

procedure TArticleListForm.DataModuleCreate(Sender: TObject);
begin
end;

procedure TArticleListForm.DataModuleRendered(Sender: TObject);
begin
  if Server.UserInfo.ID>0 then
    divNewArticle.removeClass('is-hidden');
  rdsArticles.Load;
  rdsAuthors.Load;
end;

class function TArticleListForm.FormRoutes: TStringDynArray;

begin
  Result:=['/articles/'];
end;

end.

