unit frmlogin;

{$mode ObjFPC}

interface

uses
  SysUtils, Classes, Rtl.HTMLActions, htmlfragment, Web, bulmawidgets, frmBase;

type

  THTMLFragment = TBaseForm;

  { TLoginForm }

  TLoginForm = class(THTMLFragment)
    btnDoLogin: THTMLElementAction;
    edtEmail: THTMLElementAction;
    edtPassword: THTMLElementAction;
    alForm: THTMLElementActionList;
    OKToast: TBulmaToastWidget;
    FailedToast: TBulmaToastWidget;
    procedure btnDoLoginExecute(Sender: TObject; Event: TJSEvent);
    procedure DataModuleCreate(Sender: TObject);
  private
    procedure DoLoginFailed(Sender: TObject);
    procedure DoLoginOK(Sender: TObject);

  public

  end;

var
  LoginForm: TLoginForm;

implementation

uses dmserver, frmindex, webrouter;

{$R *.lfm}

{ TLoginForm }

procedure TLoginForm.btnDoLoginExecute(Sender: TObject; Event: TJSEvent);
begin
  server.DoLogin(edtEmail.Value,edtPassword.value)
end;

procedure TLoginForm.DataModuleCreate(Sender: TObject);
begin
  Writeln('Showing login');
  Server.OnInvalidLogin:=@DoLoginFailed;
  Server.OnLogin:=@DoLoginOK;
end;

procedure TLoginForm.DoLoginFailed(Sender: TObject);
begin
  FailedToast.Refresh;
end;

procedure TLoginForm.DoLoginOK(Sender: TObject);
begin
  OKToast.Body:='Hello, '+Server.UserInfo.Login;
  OKToast.Refresh;
  IndexForm.StartLogin(Server.UserInfo.Login);
  Router.RouteRequest('/articles',True);
end;

end.

