unit services;

{$mode ObjFPC}

interface

uses
  Classes, SysUtils, fprpcclient;

Type

  { TUserService }

  TUserService = Class(TRPCCustomService)
  Protected
    Function RPCClassName : string; override;
  Public
    Function Login(Const aUserName,aPassword : String; aOnSuccess : TNativeIntResultHandler = Nil; aOnFailure : TRPCFailureCallBack = Nil) : NativeInt;
    Function Logout(aOnSuccess : TEmptyResultHandler = Nil; aOnFailure : TRPCFailureCallBack = Nil) : NativeInt;
  end;


implementation

{ TUserService }

function TUserService.RPCClassName: string;
begin
  Result:='RpcUsersModule';
end;

function TUserService.Login(const aUserName, aPassword: String; aOnSuccess: TNativeIntResultHandler; aOnFailure: TRPCFailureCallBack
  ): NativeInt;

   Procedure DoSuccess(Sender : TObject; const aResult : JSValue);

   begin
     If Assigned(aOnSuccess) then
       aOnSuccess(NativeInt(aResult));
   end;

Var
  _Params : JSValue;

begin
  StartParams;
  AddParam('UserName',aUserName);
  AddParam('Password',aPassword);
  _Params:=EndParams;
  Result:=ExecuteRequest(RPCClassName,'Login',_Params,@DoSuccess,aOnFailure);
end;

function TUserService.Logout(aOnSuccess: TEmptyResultHandler; aOnFailure: TRPCFailureCallBack): NativeInt;


   Procedure DoSuccess(Sender : TObject; const aResult : JSValue);

   begin
     If Assigned(aOnSuccess) then
       aOnSuccess();
   end;

Var
  _Params : JSValue;

begin
  StartParams;
  _Params:=EndParams;
  Result:=ExecuteRequest(RPCClassName,'Logout',_Params,@DoSuccess,aOnFailure);
end;

end.

