unit dmrpcuser;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, HTTPDefs, fpHTTP, fpjsonrpc, webjsonrpc,
  fpjson, SQLDB;

type

  { TRpcUsersModule }

  TRpcUsersModule = class(TJSONRPCModule)
    Login: TJSONRPCHandler;
    QGetUser: TSQLQuery;
    procedure DataModuleCreate(Sender: TObject);
    procedure LoginExecute(Sender: TObject; const Params: TJSONData; out
      Res: TJSONData);
  private
    FTransaction: TSQLTransaction;
    function CheckUser(const aUserName, aPassword: String): Int64;
    procedure SetTransaction(AValue: TSQLTransaction);

  public
    Property Transaction : TSQLTransaction Read FTransaction Write SetTransaction;
  end;

var
  RpcUsersModule: TRpcUsersModule;

implementation

uses jsonparser, dmserver;

{$R *.lfm}

{ TRpcUsersModule }

procedure TRpcUsersModule.LoginExecute(Sender: TObject;
  const Params: TJSONData; out Res: TJSONData);

Var
  parms : TJSONArray absolute params;
  usr,pwd : string;

begin
  usr:=parms[0].asString;
  pwd:=parms[1].asString;
  Res:=TJSONInt64Number.Create(CheckUser(usr,pwd));
end;

function TRpcUsersModule.CheckUser(const aUserName,aPassword: String) : Int64;

begin
  Result:=-1;
  With QGetUser do
    begin
    ParamByName('username').AsString:=aUserName;
    Open;
    try
      if Not IsEmpty and (aPassWord=FieldByName('U_PASSWORD').AsString) then
        Result:=FieldByName('U_ID').AsLargeInt;
    finally
      Close;
    end;
    end;
end;

procedure TRpcUsersModule.SetTransaction(AValue: TSQLTransaction);

Var
  C : TComponent;
  Q : TSQLQuery absolute C;

begin
  if FTransaction=AValue then Exit;
  FTransaction:=AValue;
  For C in Self do
    if C is TSQLQuery then
      Q.Transaction:=FTransaction;
end;

procedure TRpcUsersModule.DataModuleCreate(Sender: TObject);
begin
  Transaction:=serverModule.GetTransaction(Self);
end;

initialization
  RegisterHTTPModule('RPC', TRpcUsersModule);
//  JSONRPCHandlerManager.RegisterDatamodule(TRpcUsersModule, 'Users');
end.

